import 'dart:convert';
import 'dart:developer';
import 'dart:io';
import 'package:http/http.dart' as http;
import 'package:unit2/model/passo/general_description.dart';
import 'package:unit2/utils/request.dart';
import 'package:unit2/utils/urls.dart';

class GeneralDescriptionServices {
  static final GeneralDescriptionServices _instance =
      GeneralDescriptionServices();
  static GeneralDescriptionServices get instance => _instance;

  String xClientKey = "unitK3CQaXiWlPReDsBzmmwBZPd9Re1z";
  String xClientKeySecret = "unitcYqAN7GGalyz";

  Future<GeneralDesc> fetch(tempID) async {
    String path = Url.instance.generalDescription();
    Map<String, String> headers = {
      'Content-Type': 'application/json; charset=UTF-8',
      'X-Client-Key': xClientKey,
      'X-Client-Secret': xClientKeySecret
    };
    Map<String, String> params = {
      "bldgappr_details_id": tempID.toString(),
    };
    try {
      http.Response response = await Request.instance
          .getRequest(param: params, path: path, headers: headers);
      print('GenDescEdit');
      print(response.body);
      if (response.statusCode == 200) {
        final jsonData = jsonDecode(response.body);
        final dataList = jsonData['data'] as List<dynamic>;
        final result =
            GeneralDesc.fromJson(dataList[0] as Map<String, dynamic>);

        return result;
      } else {
        print(response.reasonPhrase);
        throw Exception(response.reasonPhrase);
      }
    } catch (e) {
      throw e.toString();
    }
  }

  Future<http.Response?> update(GeneralDesc data, id) async {
    String path = Url.instance.generalDescription();
    Map<String, String> headers = {
      'Content-Type': 'application/json; charset=UTF-8',
      'X-Client-Key': xClientKey,
      'X-Client-Secret': xClientKeySecret
    };
    Map<String, String> params = {
      "bldgappr_details_id": id,
    };
    http.Response? response;
    try {
      print(id);
      response = await Request.instance.putRequest(
          path: path, body: data.toJson(), headers: headers, param: params);
      print(response.body);
    } catch (e) {
      throw e.toString();
    }
    return response;
  }
}
